;#########################################################################################################
;###################*******************************#######################################################
;###################  B L I N D         C R Y P T  #######################################################
;###################  blind_crypt.tnick@yahoo.com  #######################################################
;###################_______________________________#######################################################
;#########################################################################################################

;
;					# Files work.asm #
;

.386
option casemap:none
.CODE

AddFilesToPrj	proc	uses esi edi ebx
;it allow adding files to project; GetOpenFileName function is used to let
;the user choose the file (s)  to be added
;selected files are added to the list, selected, extended memory is allocated for them with
;default values
LOCAL	pMemLoc		:DWORD			;if we'll need more memory,this will be the pointer 
LOCAL	pUsedBuffer	:DWORD			;memory used in the process
LOCAL	OffsetPaste	:DWORD			;for multiple files; length of the path
LOCAL	IdxCrt		:DWORD			;index for newly added file
LOCAL	OFN			:OPENFILENAME	;GetOpenFileName use this
	
	;no items selected in the list at this point
	INVOKE	SendMessage,			hWnd_List_Gen,LB_SETSEL,FALSE,-1
	mov		pMemLoc,				0
	;let's fill this members
	mov		OFN.lStructSize,		SIZEOF OPENFILENAME
	mov		eax,					hWndMain
	mov		ecx,					hInstance
	mov		edx,					pBuffer_1000h
	mov		OFN.hwndOwner,			eax	
	mov		OFN.hInstance,			ecx
	mov		dword ptr [edx],		0	
	mov		OFN.lpstrFilter,		OFFSET Filter_All
	mov		OFN.lpstrCustomFilter,	0
	mov		OFN.nMaxCustFilter,		0
	mov		OFN.nFilterIndex,		1
	mov		OFN.lpstrFile,			edx
	mov		OFN.nMaxFile,			1000h
	mov		OFN.lpstrFileTitle,		0
	mov		OFN.nMaxFileTitle,		0
	mov		OFN.lpstrInitialDir,	0
	mov		OFN.lpstrTitle,			OFFSET Title_AddFile
	mov		OFN.Flags,				OFN_LONGNAMES or OFN_EXPLORER or OFN_ALLOWMULTISELECT or OFN_FILEMUSTEXIST or OFN_HIDEREADONLY or OFN_NONETWORKBUTTON
	mov		OFN.lpstrDefExt,		0
	mov		OFN.lCustData,			0
	mov		OFN.lpfnHook,			0
	mov		OFN.lpTemplateName,		0
	;let the user chose now
	INVOKE	GetOpenFileName,		addr OFN
	;is there a error?
	.IF		eax==0
		;Really? What kind?
		INVOKE	CommDlgExtendedError
		;not enough memory to hold all those files
		.IF		eax==FNERR_BUFFERTOOSMALL 
			;may I have more memory?
			INVOKE	MessageBox,				hWndMain,addr Err_01,0,MB_OKCANCEL or MB_ICONQUESTION
			;yes? thanks ...
			.IF		eax==IDOK
				;this should do the job
				INVOKE	HeapAlloc,				hHeap,HEAP_ZERO_MEMORY,10000h
				mov		pMemLoc,				eax
				mov		pUsedBuffer,			eax
				mov		OFN.lpstrFile,			eax
				mov		OFN.nMaxFile,			10000h
				;try again!!
				INVOKE	GetOpenFileName,		addr OFN
				or		eax,					eax
				jz		EndIfOrSo
				mov		esi,					pMemLoc
			;no? well, bye then !
			.ELSE
				;I'm going out
				ret
			.ENDIF
		;I don't know this error.
		.ELSE
			;sorry!
			ret
		.ENDIF
	.ELSE
		mov		eax,							pBuffer_1000h
		mov		pUsedBuffer,					eax			
	.ENDIF
	;and now ...
	xor		ecx,					ecx	
	mov		esi,					pUsedBuffer
	mov		 cx,					OFN.nFileOffset
	add		esi,					ecx	
	;there are multiple files?
	.IF		byte ptr [esi-1]==0
		;yes. visual efects came first
		mov		eax,				OFFSET ButtonsProp
		mov		(strButPrp ptr [eax+But_SelMul]).Status,StatBut_Down
		mov		(strButPrp ptr [eax+But_SelAll]).Enabled,Enabled_TRUE
		mov		(strButPrp ptr [eax+But_InvSel]).Enabled,Enabled_TRUE
		INVOKE	DrawButton,		hDCBuffMain,But_SelMul,TRUE
		INVOKE	DrawButton,		hDCBuffMain,But_SelAll,TRUE
		INVOKE	DrawButton,		hDCBuffMain,But_InvSel,TRUE
		;must be an \ at the end of the path, isn't it so?
		mov		edi,					esi
		.IF		byte ptr [edi-2]=="\"
			dec		edi			
		.ELSE
			mov		byte ptr [edi-1],		"\"
		.endif		
		mov		OffsetPaste,			edi
		
		FullName_IN:
			;just copy from here to there
			mov		al,						byte ptr [esi+ebx]
			mov		byte ptr [edi+ebx],		al
			inc		esi
			inc		edi
			xor		ebx,					ebx
			;and when a zero is found
			.IF		al==0
				;we dont't want to process same file twice
				INVOKE	SearchForName,		pUsedBuffer
				;is there an error?
				cmp		eax,				-1
				je		FullName_OUT
				;duplicates?
				cmp		eax,				1
				je		NextHere
				;ok, ok! We add the file in our list ...
				INVOKE	SendMessage,		hWnd_List_Gen,LB_ADDSTRING,0,pUsedBuffer
				;still no error?
				cmp		eax,				LB_ERR
				je		FullName_OUT
				cmp		eax,				LB_ERRSPACE
				je		FullName_OUT
				mov		IdxCrt,				eax
				;great program, man.. no errors and all :). I need some memory now.
				INVOKE	HeapAlloc,			hHeap,0,Ptr_MExtra_MaskName
				mov		 word ptr [eax+Ptr_MExtra_DimMaskName],	0
				mov		dword ptr [eax+Ptr_MExtra_Pass],		MExtra_Pass_Without
				mov		 byte ptr [eax+Ptr_MExtra_Status],		MExtra_Status_Decoded
				INVOKE	SendMessage,		hWnd_List_Gen,LB_SETITEMDATA,IdxCrt,eax
				;and I want that file to be selected
				INVOKE	SendMessage,		hWnd_List_Gen,LB_SETSEL,TRUE,IdxCrt
				
				NextHere:
				;and the story goes on
				mov		edi,				OffsetPaste
				cmp		byte ptr [esi],		0
				je		FullName_OUT
			.endif
			jmp		FullName_IN
		FullName_OUT:
		
	.ELSE
		;no, just one file. Duplicates?
		INVOKE	SearchForName,		pUsedBuffer
		cmp		eax,				0
		jne		EndIfOrSo
		;and visual part
		mov		eax,				OFFSET ButtonsProp
		add		eax,				But_SelMul
		mov		(strButPrp ptr [eax]).Status,StatBut_Up
		INVOKE	DrawButton,		hDCBuffMain,But_SelMul,TRUE
		;add this file, then, mate
		INVOKE	SendMessage,		hWnd_List_Gen,LB_ADDSTRING,0,pUsedBuffer
		mov		IdxCrt,				eax
		;It will need some memory
		INVOKE	HeapAlloc,			hHeap,0,Ptr_MExtra_MaskName
		mov		 word ptr [eax+Ptr_MExtra_DimMaskName],	0
		mov		dword ptr [eax+Ptr_MExtra_Pass],		MExtra_Pass_Without
		mov		 byte ptr [eax+Ptr_MExtra_Status],		MExtra_Status_Decoded
		INVOKE	SendMessage,		hWnd_List_Gen,LB_SETITEMDATA,IdxCrt,eax
		;selected ...
		INVOKE	SendMessage,		hWnd_List_Gen,LB_SETSEL,TRUE,IdxCrt
	.ENDIF
	EndIfOrSo:
	;visual opart again?
	INVOKE	ShowInterface,	ShowType_InfoSel
	;get rid of that huge buffer
	.IF		pMemLoc!=0
		INVOKE	HeapFree,		hHeap,0,pMemLoc
	.ENDIF
	;that was all, folks.
ret
AddFilesToPrj 	endp

RemFilesFromPrj		proc	uses ebx esi
;it removes selected files from the project
;it will take care of extended memory, don't you worry
	
	;number of items in list
	INVOKE	SendMessage,		hWnd_List_Gen,LB_GETCOUNT,0,0
	mov		ebx,				eax
	;and for each item...
	.WHILE	ebx>0
		dec		ebx
		;if it is selected
		INVOKE	SendMessage,		hWnd_List_Gen,LB_GETSEL,ebx,0
		.IF		eax!=0
			;where is that memory?
			INVOKE	SendMessage,		hWnd_List_Gen,LB_GETITEMDATA,ebx,0
			mov		esi,				eax
			;so ... are you encoded?
			.IF		byte ptr [esi+Ptr_MExtra_Status]==MExtra_Status_Decoded
				;no? I'll give your memory to Windows, then!
				INVOKE	HeapFree,			hHeap,0,esi
				;and the item is gone
				INVOKE	SendMessage,		hWnd_List_Gen,LB_DELETESTRING,ebx,0
			.ENDIF
		.ENDIF
	.ENDW
	;don't you hate visual?
	INVOKE	ShowInterface,	ShowType_InfoSel
	;this was easy!
ret
RemFilesFromPrj 		endp

EncodeSelection		proc	uses ebx esi edi 	CounterVar:DWORD;we'll use this as a counter
;this one here encodes all selected files in the list
;it also shows some kind of status window
;new status is, of course, saved in extended memory
LOCAL	hFileCrt		:DWORD		;handle to the file that is encoded
LOCAL	SelectedFiles	:DWORD		;number of selected items in the list

	
	;we'll need  memory for this
	INVOKE	HeapAlloc,				hHeap,HEAP_ZERO_MEMORY,DimBuffEncDcd
	mov		pBuffer_EncDec,			eax
	or		eax,					eax
	jz		LeAveTheFunction
	;number of items in the list
	INVOKE	SendMessage,			hWnd_List_Gen,LB_GETCOUNT,0,0
	mov		CounterVar,				eax
	;number of selected items
	INVOKE	SendMessage,			hWnd_List_Gen,LB_GETSELCOUNT,0,0
	mov		SelectedFiles,			eax
	;go through all those items
	.WHILE	CounterVar>0   
		;the user said that he doesn't want to complete this operation?
		cmp		SelectedFiles,		0
		je		LabelHere
		cmp		MySemaphore_1,		Semaph_Red
		je		LeAveTheFunction
		dec		CounterVar
		;is selected?
		INVOKE	SendMessage,		hWnd_List_Gen,LB_GETSEL,CounterVar,0
		.IF		eax!=0;yes, it is
			;where is that extended memory ... 
			INVOKE	SendMessage,		hWnd_List_Gen,LB_GETITEMDATA,CounterVar,0
			mov		esi,				eax
			;already encoded? next file, please!
			cmp		byte ptr [esi+Ptr_MExtra_Status],	MExtra_Status_Encoded
			je		NextPlease
			;pass is not here? next!
			cmp		dword ptr [esi+Ptr_MExtra_Pass],	MExtra_Pass_NotInM
			je		NextPlease
			;so this is your path and name
			INVOKE	SendMessage,		hWnd_List_Gen,LB_GETTEXT,CounterVar,pBuffer_1000h
			INVOKE	SendMessage,		hWndS_E_Info,WM_SETTEXT,0,pBuffer_1000h
			;do you have a mask file?
			.IF		word ptr [esi+Ptr_MExtra_DimMaskName]==0
				;no mask file. let's open the real one then
				INVOKE	CreateFile,			pBuffer_1000h,GENERIC_READ or GENERIC_WRITE,0,0,OPEN_EXISTING,0,0
				cmp		eax,				INVALID_HANDLE_VALUE
				je		NextPlease
				mov		hFileCrt,			eax
			.ELSE
				;real file is moved to mask file
				mov		edi,				esi
				add		edi,				Ptr_MExtra_MaskName
				INVOKE	MoveFileEx,			pBuffer_1000h,edi,MOVEFILE_COPY_ALLOWED or MOVEFILE_REPLACE_EXISTING 
				or		eax,				eax
				jz		NextPlease
				;mask file should be opened
				INVOKE	CreateFile,			edi,GENERIC_READ or GENERIC_WRITE,0,0,OPEN_EXISTING,0,0
				cmp		eax,				INVALID_HANDLE_VALUE
				je		NextPlease
				mov		hFileCrt,			eax
			.ENDIF
			;status will be changed
			mov		byte ptr [esi+Ptr_MExtra_Status],	MExtra_Status_Encoded			
			;does this file have a pass?
			.IF		dword ptr [esi+Ptr_MExtra_Pass]==MExtra_Pass_Without
				;no	- pass from the project will be used. Not good.
				mov		esi,				OFFSET PrjPassword
			.ELSE
				;yesss - it goes to it's place
				add		esi,				Ptr_MExtra_Pass
			.ENDIF
			;let's copy that pass now
			xor		ecx,				ecx
			mov		edi,				OFFSET FilePassword
			.WHILE	ecx<DimPassFile
				mov		dl,				byte ptr [esi+ecx]
				mov		byte ptr [edi+ecx],dl
				inc		ecx
			.ENDW
			;move that slider
			INVOKE	IMNotStuck
			;and here the action take place
			INVOKE	EncodeFile,		hFileCrt
			;we are done. don't need this handle any more
			INVOKE	CloseHandle,		hFileCrt
			NextPlease:
			dec		SelectedFiles
		.ENDIF
	.ENDW
	;WE ARE DONE!!! HELLO!!! MAIN THREAD!!!
	LabelHere:
	INVOKE	PostThreadMessage,	IDTH_Main,WM_QUIT,0,0
	LeAveTheFunction:
	;no need for this one
	.IF		pBuffer_EncDec!=0
		INVOKE	HeapFree,		hHeap,0,pBuffer_EncDec
	.ENDIF
	;;consisten interface
	INVOKE	ShowInterface,	ShowType_InfoSel
	;don't miss any change in project
	INVOKE	SavePrjToDisk
ret
EncodeSelection 		endp

DecodeSelection		proc	uses ebx esi edi	CounterVar:DWORD;we'll use this as a counter
;it decodes all selected files in the list
;also,it shows a status window and the status is change in the extended memory
LOCAL	hFileCrt		:DWORD	;handle for crt file
LOCAL	SelectedFiles	:DWORD	;number of selected items in the list

	;memory for process
	INVOKE	HeapAlloc,				hHeap,HEAP_ZERO_MEMORY,DimBuffEncDcd
	mov		pBuffer_EncDec,			eax
	or		eax,					eax
	jz		CtrFunction_Out
	;number of elements in the list
	INVOKE	SendMessage,			hWnd_List_Gen,LB_GETCOUNT,0,0
	mov		CounterVar,				eax
	;numberof selected items
	INVOKE	SendMessage,			hWnd_List_Gen,LB_GETSELCOUNT,0,0
	mov		SelectedFiles,			eax
	;one at a time
	.WHILE	CounterVar>0
		;no selected file left
		cmp		SelectedFiles,		0
		je		LabelHere
		;does the user choose cancel?
		cmp		MySemaphore_1,		Semaph_Red
		je		CtrFunction_Out
		dec		CounterVar
		;if is selected
		INVOKE	SendMessage,		hWnd_List_Gen,LB_GETSEL,CounterVar,0
		.IF		eax!=0
			;pointer to it's extended memory
			INVOKE	SendMessage,		hWnd_List_Gen,LB_GETITEMDATA,CounterVar,0
			mov		esi,				eax
			;already encoded ... 
			cmp		byte ptr [esi+Ptr_MExtra_Status],	MExtra_Status_Decoded
			je		NextPlease
			;no password in memory ...
			cmp		dword ptr [esi+Ptr_MExtra_Pass],	MExtra_Pass_NotInM
			je		NextPlease
			;path to real file
			INVOKE	SendMessage,		hWnd_List_Gen,LB_GETTEXT,CounterVar,pBuffer_1000h
			;is there a mask?
			.IF		word ptr [esi+Ptr_MExtra_DimMaskName]!=0
				;copy this file to mask file
				mov		edi,				esi
				add		edi,				Ptr_MExtra_MaskName
				INVOKE	MoveFileEx,			edi,pBuffer_1000h,MOVEFILE_COPY_ALLOWED or MOVEFILE_REPLACE_EXISTING 
				or		eax,				eax
				jz		NextPlease
			.ENDIF
			mov		edi,				pBuffer_1000h
			;status window
			INVOKE	IMNotStuck
			;let's open the file
			INVOKE	SendMessage,		hWndS_E_Info,WM_SETTEXT,0,pBuffer_1000h
			INVOKE	CreateFile,			edi,GENERIC_READ or GENERIC_WRITE,0,0,OPEN_EXISTING,0,0
			cmp		eax,				INVALID_HANDLE_VALUE
			je		NextPlease
			mov		hFileCrt,			eax
			;status will be changed
			mov		byte ptr [esi+Ptr_MExtra_Status],	MExtra_Status_Decoded
			;is there a pass?
			.IF		dword ptr [esi+Ptr_MExtra_Pass]==MExtra_Pass_Without
				;no! use project's! Not good again!
				mov		esi,				OFFSET PrjPassword
			.ELSE
				;Yes! My greetings, user!
				add		esi,				Ptr_MExtra_Pass
			.ENDIF
			;copy that pass to it's place
			xor		ecx,				ecx
			mov		edi,				OFFSET FilePassword
			.WHILE	ecx<DimPassFile
				mov		dl,				byte ptr [esi+ecx]
				mov		byte ptr [edi+ecx],dl
				inc		ecx
			.ENDW
			;status window
			INVOKE	IMNotStuck
			;action!!!
			INVOKE	DecodeFile,		hFileCrt
			;close this handle
			INVOKE	CloseHandle,		hFileCrt
			NextPlease:
			dec		SelectedFiles
		.ENDIF
	.ENDW
	LabelHere:
	;status no more
	INVOKE	PostThreadMessage,	IDTH_Main,WM_QUIT,0,0
	CtrFunction_Out:
	;here's some memory, OS
	.IF		pBuffer_EncDec!=0
		INVOKE	HeapFree,		hHeap,0,pBuffer_EncDec
	.ENDIF
	;consistent interface
	INVOKE	ShowInterface,	ShowType_InfoSel
	;put it all on the disc
	INVOKE	SavePrjToDisk
ret
DecodeSelection 		endp

DeleteMask			proc	uses ebx esi edi
;it removes the mask file from extended memory ... if possible (decoded, selected)
;dimension in the extended memory will be 0
	
	;total number of items in list
	INVOKE	SendMessage,	hWnd_List_Gen,LB_GETCOUNT,0,0
	mov		ebx,			eax
	.IF		eax==LB_ERR
		INVOKE	MessageBox,		hWndMain,ADDR Err_16,0,MB_OK or MB_ICONERROR
		jmp		GetOutOfHere
	.ENDIF
	;selected items
	INVOKE	SendMessage,	hWnd_List_Gen,LB_GETSELCOUNT,0,0
	mov		esi,			eax
	.IF		eax==LB_ERR
		INVOKE	MessageBox,		hWndMain,ADDR Err_16,0,MB_OK or MB_ICONERROR
		jmp		GetOutOfHere
	.ENDIF
	;again this loop
	.WHILE	ebx>0
		dec		ebx
		;selected?
		INVOKE	SendMessage,		hWnd_List_Gen,LB_GETSEL,ebx,0
		.IF		eax==LB_ERR
			;error
			INVOKE	MessageBox,		hWndMain,ADDR Err_16,0,MB_OK or MB_ICONERROR
			jmp		GetOutOfHere
		.ELSEIF	eax!=0
			;pointer to extended memory
			INVOKE	SendMessage,		hWnd_List_Gen,LB_GETITEMDATA,ebx,0
			;encoded?
			.IF		byte ptr [eax+Ptr_MExtra_Status]==MExtra_Status_Decoded
;				push	eax
;				;delete this one
;				add		eax,			Ptr_MExtra_MaskName
;				INVOKE	DeleteFile,		eax
;				pop		eax
				;no. get rid of that name
				INVOKE	HeapReAlloc,	hHeap,0,eax,(Ptr_MExtra_DimMaskName+3)
				mov		word ptr [eax+Ptr_MExtra_DimMaskName],	0
				;back to your item
				INVOKE	SendMessage,	hWnd_List_Gen,LB_SETITEMDATA,ebx,eax
			.ENDIF
			dec		esi
			.BREAK	.IF esi==0
		.ENDIF
	.ENDW
	;visual confirmation
	INVOKE	ShowInterface,		ShowType_InfoSel
	
GetOutOfHere:
ret
DeleteMask 			endp

DeletePass			proc		DeUnde:DWORD
;removes the pass from extended memory
;if the file is decoded, it can remove the password for goodlet parola

	;items in list
	INVOKE	SendMessage,	hWnd_List_Gen,LB_GETCOUNT,0,0
	mov		ebx,			eax
	.IF		eax==LB_ERR
		INVOKE	MessageBox,		hWndMain,ADDR Err_16,0,MB_OK or MB_ICONERROR
		jmp		GetOutOfHere
	.ENDIF
	;selected items
	INVOKE	SendMessage,	hWnd_List_Gen,LB_GETSELCOUNT,0,0
	mov		esi,			eax
	.IF		eax==LB_ERR
		INVOKE	MessageBox,		hWndMain,ADDR Err_16,0,MB_OK or MB_ICONERROR
		jmp		GetOutOfHere
	.ENDIF
	;...
	.WHILE	ebx>0
		dec		ebx
		;selected?
		INVOKE	SendMessage,		hWnd_List_Gen,LB_GETSEL,ebx,0
		.IF		eax==LB_ERR
			INVOKE	MessageBox,		hWndMain,ADDR Err_16,0,MB_OK or MB_ICONERROR
			jmp		GetOutOfHere
		.ELSEIF	eax!=0
			;pointer to memory
			INVOKE	SendMessage,		hWnd_List_Gen,LB_GETITEMDATA,ebx,0
			.IF		eax==LB_ERR
				INVOKE	MessageBox,		hWndMain,ADDR Err_16,0,MB_OK or MB_ICONERROR
				jmp		GetOutOfHere
			.ENDIF
			;remove thet pass
			xor		ecx,				ecx
			.WHILE	ecx<Ptr_MExtra_Status
				mov		byte ptr [eax+ecx],	0FFh
				inc		ecx
			.ENDW
			;status as requested
			.IF		DeUnde==DelType_FromMem
				mov		dword ptr [eax+Ptr_MExtra_Pass],	MExtra_Pass_NotInM
			.ELSEIF	byte ptr [eax+Ptr_MExtra_Status]==MExtra_Status_Decoded
				mov		dword ptr [eax+Ptr_MExtra_Pass],	MExtra_Pass_Without
;			.ELSE
;				mov		dword ptr [eax+Ptr_MExtra_Pass],	MExtra_Pass_NotInM
			.ENDIF
			dec		esi
			.BREAK	.IF esi==0
		.ENDIF
	.ENDW
	INVOKE	ShowInterface,		ShowType_InfoSel
	
GetOutOfHere:
ret
DeletePass 			endp

EncodeFile		proc		uses ebx edi esi	hFileCrt:DWORD
;what can I say?! this is THE proc
LOCAL	FIleSizeDW			:DWORD
LOCAL	CrtOffsetDW			:DWORD
LOCAL	Answer					:DWORD

	INVOKE	GetFileSize,		hFileCrt,ADDR Answer
	mov		FIleSizeDW,		eax			
	
	xor		ebx,				ebx		
	mov		esi,				pBuffer_EncDec	
	.IF		FIleSizeDW<=DimBuffEncDcd	
		INVOKE	SetFilePointer,		hFileCrt,0,0,FILE_BEGIN	
		INVOKE	ReadFile,			hFileCrt,pBuffer_EncDec,FIleSizeDW,addr Answer,0
		.WHILE	ebx<FIleSizeDW					
			mov		eax,			ebx
			xor		edx,			edx					
			mov		ecx,			DimPassPrj
			div		ecx								
			add		edx,			OFFSET PrjPassword
			xor		eax,			eax				
			mov		al,				byte ptr [edx]	
			shl		eax,			2					
			xor		edx,			edx			
			add		eax,			ebx	
			div		FIleSizeDW				
			mov		edi,			edx			
			mov		eax,			ebx			
			xor		edx,			edx
			mov		ecx,			DimPassFile
			div		ecx								
			xor		eax,			eax
			add		edx,			OFFSET FilePassword	
			mov		al,				byte ptr [edx]	
			mov		cl,				16						
			div		cl
			mov		cx,				ax
			mov		al,				byte ptr [esi+ebx]
			mov		ah,				byte ptr [esi+edi]
					rol		al,				cl
					rol		cx,				8
					rol		ah,				cl	
					not		al
					not		ah
			mov		byte ptr [esi+ebx],	ah
			mov		byte ptr [esi+edi],	al
			add		ebx,			1
		.ENDW
		INVOKE	SetFilePointer,		hFileCrt,0,0,FILE_BEGIN
		INVOKE	WriteFile,			hFileCrt,pBuffer_EncDec,FIleSizeDW,addr Answer,0
	.ELSE
		mov		CrtOffsetDW,		0	
		INVOKE	SetFilePointer,		hFileCrt,0,0,FILE_BEGIN
		INVOKE	ReadFile,			hFileCrt,pBuffer_EncDec,DimBuffEncDcd,addr Answer,0
		.WHILE	ebx<FIleSizeDW
			
			mov		eax,			ebx
			xor		edx,			edx
			mov		ecx,			DimPassPrj
			div		ecx
			add		edx,			OFFSET PrjPassword
			xor		eax,			eax
			mov		al,				byte ptr [edx]
			shl		eax,			2		
			add		eax,			ebx
			mov		edi,			eax
			mov		eax,			ebx
			xor		edx,			edx
			mov		ecx,			DimPassFile
			div		ecx
			add		edx,			OFFSET FilePassword
			xor		eax,			eax
			mov		al,				byte ptr [edx]
			mov		cl,				16
			div		cl
			mov		cx,				ax
			sub		edi,			CrtOffsetDW
			mov		edx,			ebx
			sub		edx,			CrtOffsetDW
			mov		al,				byte ptr [esi+edx]
			mov		ah,				byte ptr [esi+edi]
					rol		al,				cl
					rol		cx,				8
					rol		ah,				cl	
					not		al
					not		ah
			mov		byte ptr [esi+edx],	ah
			mov		byte ptr [esi+edi],	al
			inc		ebx
		.BREAK .IF ebx==FIleSizeDW
			mov		eax,				CrtOffsetDW
			add		eax,				(DimBuffEncDcd-400h)
			.IF		ebx>=eax
				INVOKE	IMNotStuck
				INVOKE	SetFilePointer,		hFileCrt,CrtOffsetDW,0,FILE_BEGIN
				mov		eax,				CrtOffsetDW
				add		eax,				DimBuffEncDcd
				.IF		eax<=FIleSizeDW
					INVOKE	WriteFile,			hFileCrt,pBuffer_EncDec,DimBuffEncDcd,addr Answer,0
				.ELSE
					mov		edi,				FIleSizeDW
					sub		edi,				CrtOffsetDW
					INVOKE	WriteFile,			hFileCrt,pBuffer_EncDec,edi,addr Answer,0
					INVOKE	SetFilePointer,		hFileCrt,0,0,FILE_BEGIN
					mov		ecx,				DimBuffEncDcd
					sub		ecx,				edi
					add		edi,				pBuffer_EncDec
					INVOKE	WriteFile,			hFileCrt,edi,ecx,addr Answer,0
				.ENDIF				
				add		CrtOffsetDW,		(DimBuffEncDcd-400h)
				INVOKE	SetFilePointer,		hFileCrt,CrtOffsetDW,0,FILE_BEGIN
				mov		eax,				CrtOffsetDW
				add		eax,				DimBuffEncDcd
				.IF		eax<=FIleSizeDW
					INVOKE	ReadFile,			hFileCrt,pBuffer_EncDec,DimBuffEncDcd,addr Answer,0
				.ELSE
					mov		edi,				FIleSizeDW
					sub		edi,				CrtOffsetDW
					INVOKE	ReadFile,			hFileCrt,pBuffer_EncDec,edi,addr Answer,0
					INVOKE	SetFilePointer,		hFileCrt,0,0,FILE_BEGIN
					mov		ecx,				DimBuffEncDcd
					sub		ecx,				edi
					add		edi,				pBuffer_EncDec
					INVOKE	ReadFile,			hFileCrt,edi,ecx,addr Answer,0
				.ENDIF
			.ENDIF
		.ENDW		
		INVOKE	SetFilePointer,		hFileCrt,CrtOffsetDW,0,FILE_BEGIN
		mov		edi,				FIleSizeDW
		sub		edi,				CrtOffsetDW
		INVOKE	WriteFile,			hFileCrt,pBuffer_EncDec,edi,addr Answer,0
		INVOKE	SetFilePointer,		hFileCrt,0,0,FILE_BEGIN
		mov		ecx,				DimBuffEncDcd
		sub		ecx,				edi
		add		edi,				pBuffer_EncDec
		INVOKE	WriteFile,			hFileCrt,edi,ecx,addr Answer,0
	.ENDIF	
ret
EncodeFile 		endp

DecodeFile		proc		uses ebx edi esi	hFileCrt:DWORD
;and this is the other PROC
LOCAL	FIleSizeDW			:DWORD
LOCAL	CrtOffsetDW			:DWORD
LOCAL	Answer					:DWORD
	
	
	INVOKE	GetFileSize,		hFileCrt,ADDR Answer
	mov		FIleSizeDW,		eax
	mov		ebx,				FIleSizeDW
	mov		esi,				pBuffer_EncDec
	.IF		ebx<=DimBuffEncDcd
		INVOKE	SetFilePointer,		hFileCrt,0,0,FILE_BEGIN
		INVOKE	ReadFile,			hFileCrt,pBuffer_EncDec,FIleSizeDW,addr Answer,0
		.WHILE	ebx>=0
			dec		ebx
			mov		eax,			ebx
			xor		edx,			edx
			mov		ecx,			DimPassPrj
			div		ecx
			add		edx,			OFFSET PrjPassword
			xor		eax,			eax
			mov		al,				byte ptr [edx]
			shl		eax,			2
			add		eax,			ebx
			xor		edx,			edx
			div		FIleSizeDW
			push	edx
			mov		eax,			ebx
			xor		edx,			edx
			mov		ecx,			DimPassFile
			div		ecx
			add		edx,			OFFSET FilePassword
			xor		eax,			eax
			mov		al,				byte ptr [edx]
			mov		cl,				16
			div		cl
			mov		cx,				ax
			pop		edx		
			mov		al,				byte ptr [esi+ebx]
			mov		ah,				byte ptr [esi+edx]
					ror		ah,				cl
					rol		cx,				8
					ror		al,				cl
					not		al
					not		ah
			mov		byte ptr [esi+ebx],	ah
			mov		byte ptr [esi+edx],	al
		
		.BREAK	.IF	ebx==0
		.ENDW
		INVOKE	SetFilePointer,		hFileCrt,0,0,FILE_BEGIN
		INVOKE	WriteFile,			hFileCrt,pBuffer_EncDec,FIleSizeDW,addr Answer,0
	.ELSE
		mov		eax,				FIleSizeDW
		xor		edx,				edx
		mov		ecx,				(DimBuffEncDcd-400h)
		div		ecx
		.IF		edx==0
			dec		eax
		.ENDIF
		xor		edx,				edx
		mul		ecx
		mov		edi,				FIleSizeDW
		sub		edi,				eax	
		mov		CrtOffsetDW,		eax
		INVOKE	SetFilePointer,		hFileCrt,eax,0,FILE_BEGIN
		INVOKE	ReadFile,			hFileCrt,pBuffer_EncDec,edi,addr Answer,0
		INVOKE	IMNotStuck
		INVOKE	SetFilePointer,		hFileCrt,0,0,FILE_BEGIN
		mov		ecx,				DimBuffEncDcd
		sub		ecx,				edi
		add		edi,				pBuffer_EncDec
		INVOKE	ReadFile,			hFileCrt,edi,ecx,addr Answer,0
		
		mov		ebx,				FIleSizeDW
		mov		esi,				pBuffer_EncDec		
		.WHILE	ebx>0
			dec		ebx
			mov		eax,			ebx
			xor		edx,			edx
			mov		ecx,			DimPassPrj
			div		ecx
			add		edx,			OFFSET PrjPassword
			xor		eax,			eax
			mov		al,				byte ptr [edx]
			shl		eax,			2
			add		eax,			ebx
			mov		edi,			eax
			mov		eax,			ebx
			xor		edx,			edx
			mov		ecx,			DimPassFile
			div		ecx
			add		edx,			OFFSET FilePassword
			xor		eax,			eax
			mov		al,				byte ptr [edx]
			mov		cl,				16
			div		cl
			mov		cx,				ax
			mov		edx,			ebx
			sub		edx,			CrtOffsetDW
			sub		edi,			CrtOffsetDW
			mov		al,				byte ptr [esi+edx]
			mov		ah,				byte ptr [esi+edi]
					ror		ah,				cl
					ror		cx,				8
					ror		al,				cl
					not		al
					not		ah
			mov		byte ptr [esi+edx],	ah
			mov		byte ptr [esi+edi],	al
			
			.IF		ebx==CrtOffsetDW
				INVOKE	IMNotStuck
				INVOKE	SetFilePointer,		hFileCrt,CrtOffsetDW,0,FILE_BEGIN
				mov		eax,				CrtOffsetDW
				add		eax,				DimBuffEncDcd
				.IF		eax<=FIleSizeDW
					INVOKE	WriteFile,			hFileCrt,pBuffer_EncDec,DimBuffEncDcd,addr Answer,0
				.ELSE
					mov		edi,				FIleSizeDW
					sub		edi,				CrtOffsetDW
					INVOKE	WriteFile,			hFileCrt,pBuffer_EncDec,edi,addr Answer,0
					INVOKE	SetFilePointer,		hFileCrt,0,0,FILE_BEGIN
					mov		ecx,				DimBuffEncDcd
					sub		ecx,				edi
					add		edi,				pBuffer_EncDec
					INVOKE	WriteFile,			hFileCrt,edi,ecx,addr Answer,0
				.ENDIF
				.BREAK .IF ebx==0
				sub		CrtOffsetDW,		(DimBuffEncDcd-400h)
				INVOKE	SetFilePointer,		hFileCrt,CrtOffsetDW,0,FILE_BEGIN
				mov		eax,				CrtOffsetDW
				add		eax,				DimBuffEncDcd				
				.IF		eax<=FIleSizeDW
					INVOKE	ReadFile,			hFileCrt,pBuffer_EncDec,DimBuffEncDcd,addr Answer,0
				.ELSE
					mov		edi,				FIleSizeDW
					sub		edi,				CrtOffsetDW
					INVOKE	ReadFile,			hFileCrt,pBuffer_EncDec,edi,addr Answer,0
					INVOKE	SetFilePointer,		hFileCrt,0,0,FILE_BEGIN
					mov		ecx,				DimBuffEncDcd
					sub		ecx,				edi
					add		edi,				pBuffer_EncDec
					INVOKE	ReadFile,			hFileCrt,edi,ecx,addr Answer,0
				.ENDIF
			.ENDIF
		.BREAK	.IF	ebx==0
			
		.ENDW		
	.ENDIF
	
ret
DecodeFile 		endp

SearchForName		proc		uses edi esi		pBuffer:DWORD
;it search the given name both in real files and mask files
;return values:
;	0  - not found
;	1  - found
;	-1 - error
LOCAL	Local_Dimension		:DWORD

	;we'll need a buffer
	INVOKE	HeapAlloc,	hHeap,0,0800h
	mov		edi,			eax	
	or		eax,			eax
	jz		GetOut_Error
	mov		esi,			pBuffer
	;nr of items
	INVOKE	SendMessage,		hWnd_List_Gen,LB_GETCOUNT,0,0
	cmp		eax,				LB_ERR
	je		GetOut_Error
	mov		pBuffer,			eax ;we can use this as a counter
	mov		eax,				pPathName_CrtPrj
	xor		ecx,				ecx
	.WHILE	cx<word ptr [eax]
		mov		dl,					byte ptr [eax+ecx+2]
		cmp		dl,					byte ptr [esi+ecx]
		jne		FindInList
		inc		ecx
	.endw
	je		Out_Found
	FindInList:
	;>>>
	.WHILE	pBuffer>0
		dec		pBuffer
		;real file name and path
		INVOKE	SendMessage,		hWnd_List_Gen,LB_GETTEXT,pBuffer,edi
		cmp		eax,				LB_ERR
		je		GetOut_Error
		mov		Local_Dimension,			eax
		xor		ecx,				ecx
		;and go search
		.WHILE	ecx<Local_Dimension
			mov		dl,					byte ptr [esi+ecx]
			cmp		dl,					byte ptr [edi+ecx]
			jne		MayBeMask
			inc		ecx
		.ENDW
		cmp		byte ptr [esi+ecx],		0
		je		Out_Found
		MayBeMask:
		;get mask name
		INVOKE	SendMessage,		hWnd_List_Gen,LB_GETITEMDATA,pBuffer,0
		cmp		eax,				LB_ERR
		je		GetOut_Error
		xor		ecx,				ecx
		;go search again
		.WHILE	cx<word ptr [eax+Ptr_MExtra_DimMaskName]
			mov		dl,					byte ptr [eax+ecx+Ptr_MExtra_MaskName]
			cmp		dl,					byte ptr [esi+ecx]
			jne		NextPlease
			inc		ecx
		.ENDW
		or		ecx,				ecx
		jnz		Out_Found
		cmp		byte ptr [esi+ecx],		0
		je		Out_Found
		NextPlease:
	.ENDW
	
	
Out_NotFound:
mov		esi,	0
jmp		GetOutOfHere
Out_Found:
mov		esi,	1
jmp		GetOutOfHere
GetOut_Error:
mov		esi,	-1


GetOutOfHere:
.IF		edi!=0
INVOKE	HeapFree,		hHeap,0,edi
.ENDIF
mov		eax,	esi
ret
SearchForName 		endp







